<?php


namespace OrganizationsManagement\Repository;


use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class Classification
{
    use TQuery;
    /**
     * @var EntityManager
     */
    private $entityManager;

    /**
     * Classification constructor.
     * @param EntityManager $entityManager
     */
    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    /**
     * @return array
     */
    public function findClassificationOnliWithSubject(): array
    {
        $query = <<<SQL
            SELECT C.ID, C.LABEL, C.CDASSUNTO
              FROM CLASSIFICATION C
              JOIN ASSUNTO A ON A.CDASSUNTO = C.CDASSUNTO
              WHERE C.CDASSUNTO IS NOT NULL
              ORDER BY C.LABEL
SQL;
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $query);
    }
}
